<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="年份" prop="year">
        <el-select
          v-model="queryParams.year"
          placeholder="请选择年份"
          clearable
        >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select
          v-model="queryParams.month"
          placeholder="请选择月份"
          clearable
        >
          <el-option label="01" value="01"></el-option>
          <el-option label="02" value="02"></el-option>
          <el-option label="03" value="03"></el-option>
          <el-option label="04" value="04"></el-option>
          <el-option label="05" value="05"></el-option>
          <el-option label="06" value="06"></el-option>
          <el-option label="07" value="07"></el-option>
          <el-option label="08" value="08"></el-option>
          <el-option label="09" value="09"></el-option>
          <el-option label="10" value="10"></el-option>
          <el-option label="11" value="11"></el-option>
          <el-option label="12" value="12"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item style="margin-left: 25px;">
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
        <el-button type="primary"  size="mini" @click="handleExport"
          >导出列表</el-button
        >
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table
        v-loading="loading"
        :data="rzlInventStatisticsInfoList"
        :max-height="maxHeight"
        :header-cell-style="{ background: '#2a8eed', color: '#fafcfe' }"
      >
        <!--
        <el-table-column label="地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{scope.row.datas[0]}}</span>
          </template>
        </el-table-column>
        -->

        <el-table-column :label="hearderTitle" align="center">
          <!--
            <el-table-column v-for="(item,index) in headerList" :label="item.name" align="center" :key="index">
              <template slot-scope="scope">
                <span>{{scope.row.datas[index+2]}}</span>
              </template>
            </el-table-column>
            -->
          <el-table-column label="排名" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["ranking"] }}</span>
            </template>
          </el-table-column>
          <el-table-column label="地区" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["cityName"] }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="yearColumn1" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["yearCnt"] }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="yearColumn2" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["yearValid"] }}</span>
            </template>
          </el-table-column>
          <el-table-column :label="yearColumn3" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row["yearPopulation"] }}</span>
            </template>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>
  </div>
</template>

<script>
import {
  listRzlInventStatisticsInfo,
  getRzlInventStatisticsInfo,
  delRzlInventStatisticsInfo,
  addRzlInventStatisticsInfo,
  updateRzlInventStatisticsInfo,
  getHeaderList,
  getYearList,
} from "@/api/report/rzlInventStatisticsInfo";

export default {
  name: "RzlInventStatisticsInfo",
  data() {
    return {
      maxHeight: 0,
      yearList: [],
      headerList: [],
      hearderTitle: "统计时期:2022",
      yearColumn1: "年",
      yearColumn2: "年发明专利有效量（件）",
      yearColumn3: "年人口（万人）",
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利有效-万人发明拥有量统计表格数据
      rzlInventStatisticsInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: "2022",
        month: "12",
        higherSchool: null,
        researchInstitute: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getHeader();
    this.getList();
    this.getYear();
    this.$nextTick(() => {
      this.maxHeight = window.innerHeight - 200; //300是页面中除了表格外其他组件的高度
    });
  },
  methods: {
    handerMethod({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },

    /** 获取动态表头 */
    getHeader() {
      let head = "统计时期" + this.queryParams.year;

      this.yearColumn1 = this.queryParams.year + "年";
      this.yearColumn2 = this.queryParams.year + "年发明专利有效量（件）";
      this.yearColumn3 = this.queryParams.year + "年人口(万人)";

      if (this.queryParams.month) {
        head = head + "-" + this.queryParams.month;
      }
      this.hearderTitle = head;
      this.queryParams.startDate = this.queryParams.year;

      this.headerList = getHeaderList(this.queryParams.year);
      // getHeaderList(this.queryParams.year).then(response => {
      //   this.headerList = response.data;
      // });
    },

    /** 获取查询年份列表 */
    getYear() {
      getYearList().then((response) => {
        this.yearList = response.data;
      });
    },

    /** 查询专利有效-万人发明拥有量统计列表 */
    getList() {
      this.loading = true;
      listRzlInventStatisticsInfo(this.queryParams).then((response) => {
        this.rzlInventStatisticsInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        patentType: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        higherSchool: null,
        researchInstitute: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      if (this.queryParams.month) {
        if (this.queryParams.year) {
          this.getHeader();
          this.queryParams.pageNum = 1;
          this.getList();
        } else {
          this.$message("请选择年份");
        }
      } else {
        this.getHeader();
        this.queryParams.pageNum = 1;
        this.getList();
      }
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利有效-万人发明拥有量统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getRzlInventStatisticsInfo(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利有效-万人发明拥有量统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzlInventStatisticsInfo(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm(
          '是否确认删除专利有效-万人发明拥有量统计编号为"' + ids + '"的数据项？'
        )
        .then(function () {
          return delRzlInventStatisticsInfo(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "report/rzlInventStatisticsInfo/export",
        {
          ...this.queryParams,
        },
        `rzlInventStatisticsInfo_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
